Index: apps/app_amd.c
===================================================================
--- apps/app_amd.c	(revision 58920)
+++ apps/app_amd.c	(working copy)
@@ -91,6 +91,7 @@
 	int res = 0;
 	struct ast_frame *f = NULL;
 	struct ast_dsp *silenceDetector = NULL;
+	struct ast_silence_generator *silgen = NULL;
 	int dspsilence = 0, readFormat, framelength;
 	int inInitialSilence = 1;
 	int inGreeting = 0;
@@ -181,6 +182,9 @@
 	/* Set silence threshold to specified value */
 	ast_dsp_set_threshold(silenceDetector, silenceThreshold);
 
+	/* Start silence generator */
+	silgen = ast_channel_start_silence_generator(chan);
+
 	/* Now we go into a loop waiting for frames from the channel */
 	while ((res = ast_waitfor(chan, totalAnalysisTime)) > -1) {
 		/* If we fail to read in a frame, that means they hung up */
@@ -284,6 +288,9 @@
 		}
 		ast_frfree(f);
 	}
+
+	/* Stop silence generator */
+	ast_channel_stop_silence_generator(chan, silgen);
 	
 	if (!res) {
 		/* It took too long to get a frame back. Giving up. */
